﻿using UnityEngine;
using System.Collections;

public class House : MonoBehaviour {
	
	public int height;
	public bool weaponized = false;
	
	void Awake () {
		height = Random.Range(2,7) * 2 + 1;
	}
	
	// Generate house 
	void Start () {
		
		for (int i = 0; i<height; i++) {
			
			//add windows each 2nd row
			if (i % 2 == 0) 
				AddRow(Game.handler.genFloor, i);
			else 
				AddRow(Game.handler.genWindow, i);	
		}	
			
		if (Random.Range(0, 100) >= Game.handler.weaponizeFactor)
			//add simple roof top
			AddRow(Game.handler.genRoof, height);
		else {
			//add weaponized roof top
			AddRow(Game.handler.genRoofFire, height);
			weaponized = true;
			Game.handler.enemyCount++;
		}
	}
	
	void Update() {
		//remove if off screen
		if (Game.handler.mover.pos.x-10 > transform.position.x) {
			Destroy(gameObject);
			if (weaponized) Game.handler.enemyCount--;
		}
	}
	
	Transform AddRow( Transform genType, int floor ) {
		
		//row position depends on house position and floor number
		//use z = -1 to place house in front of other objects
		Vector3 	floorPosition 	= new Vector3(transform.position.x, floor, -1);
		
		//choose one sub element of genType randomly
		Transform 	rowType = genType.GetChild(Random.Range(0,genType.childCount));
		
		//create row
		Transform	row = Instantiate(rowType,floorPosition, Quaternion.identity) as Transform;
					row.parent = this.transform;
		return row;
	}		
}
