﻿using UnityEngine;
using System.Collections;

public class Rocket : MonoBehaviour {
	
	//rocket explosion height in pixel
	public int minExplosionHeight = 5;
	public int maxExplosionHeight = 25;
	
	public Sound explosionSound;
	
	private float startY;
	private int explosionHeight;
	
	// Use this for initialization
	void Start () {
		
		Transform shotType;
		
		startY 			= transform.position.y;	
		explosionHeight = Random.Range(minExplosionHeight, maxExplosionHeight);
	
		//choose one sub element of RocketFire randomly
		shotType = Game.handler.genRocketFire.GetChild(Random.Range(0,Game.handler.genRocketFire.childCount));
		GetComponent<Shooter>().shotType = shotType.GetComponent<Pixel>();
	}
	
	// Update is called once per frame
	void Update () {
		
		if (transform.position.y - startY > explosionHeight) Explode();
	}
	
	void OnTriggerEnter(Collider other) {
		Explode();
    }
	
	void Explode() {
		GetComponent<Pixel>().PlaySound( explosionSound );
		GetComponent<Shooter>().AutoShoot();
		Destroy(gameObject);		
	}
}
