﻿using UnityEngine;
using System.Collections;

public class Shooter : MonoBehaviour {
	
	public Pixel 	shotType;
	
	public float 	shotDelay 	  	= 0.2f;
	public float    shotRandomDelay = 0.05f;
	
	public bool		autoShoot	 	= true;		
	//number of projectiles ejected with one shot
	public int	 	autoShootCnt  	= 1;
	
	public int		shootAngle		= 90;
	public int		shootAngleRand 	= 20;	
	
	private float 	waitShot;
	
	// Use this for initialization
	void Start () {
		waitShot = Random.Range(0, shotDelay);
	}
	
	void Update () {
			
		//shot delay
		if (waitShot > 0) 
			waitShot -= Time.deltaTime;
		else 
			waitShot = 0;
		
		//shoot automatically each interval
		if ((waitShot <= 0) && autoShoot) AutoShoot();
	}
	
	// shoot single projectile
	public void Shoot ( Vector2 shotDir, Transform parent = null ) {
		
		Pixel goShot;
		
		if (waitShot > 0) return;
		
		goShot 		= Instantiate( shotType, transform.position, Quaternion.identity ) as Pixel;
		goShot.dir 	= shotDir.normalized;
		waitShot    = shotDelay + Random.Range(-shotRandomDelay,shotRandomDelay);
		
		goShot.transform.parent = parent;			
	}	
	
	public void AutoShoot() {
		
		float 	angle;
		Vector2 shootDir;
		
		//shoot defined number of projectiles automatically
		for (var i = 0; i < autoShootCnt; i++) {
		
			angle = shootAngle + Random.Range(-shootAngleRand, shootAngleRand);
			shootDir = new Vector2(Mathf.Cos(angle*Mathf.Deg2Rad), Mathf.Sin(angle*Mathf.Deg2Rad));
			Shoot( shootDir );
		}			
	}	
}
