﻿using UnityEngine;
using System.Collections;

public class Sound : MonoBehaviour {
	
	public float volume = 1f;
	
	// Use this for initialization
	void Update () {
		//destroy object after 2 seconds latest
		if (!audio.loop) Destroy(gameObject,2);
		
		//set pan and volume according to position
		audio.pan 	 = (transform.position.x - Camera.main.transform.position.x) / 30f;
		audio.volume = volume - (Mathf.Abs(transform.position.x - Camera.main.transform.position.x) / 60f);
		
		//necessary?
		audio.pan    = Mathf.Clamp(audio.pan,-1f,1f);
		audio.volume = Mathf.Clamp(audio.volume,0f,1f);
		
		//out of audio range, no need to keep the object
		if (!audio.loop && (audio.volume == 0)) Destroy(gameObject);		
	}
}
